<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

$_CUR = 'distribution';
require (dirname(__FILE__) . '/include/init.php');
$smarty->assign('cur', $_CUR);

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'default';

// 引入和实例化分销功能
include_once (ROOT_PATH . 'include/distribution.class.php');
$dou_distribution = new Distribution();

// 实例化
include_once (ROOT_PATH . 'include/money.class.php');
$dou_money = new Money();

// 赋值给模板
$smarty->assign('rec', $rec);

/**
 * +----------------------------------------------------------
 * 分销申请列表
 * +----------------------------------------------------------
 */
if ($rec == 'default') {
    $smarty->assign('ur_here', $_LANG['distribution_apply']);
 
    // 初始化
    $page_url = 'distribution.php';
 
    // 用户名
    $username = $check->is_username($_REQUEST['username']) ? $_REQUEST['username'] : '';
    if ($username) {
        $user_id = $dou->search_user_id($username);
        $where = " AND user_id = '$user_id'";
        $page_url = $page_url . "&username=$username";
    }

    // 筛选.时间
    $time_end = isset($_REQUEST['time_end']) ? trim($_REQUEST['time_end']) : '';
    $time_start = isset($_REQUEST['time_start']) ? trim($_REQUEST['time_start']) : '';
    if ($time_start) {
        $where = $where . " AND add_time > '" . strtotime($time_start) . "'";
        $page_url = $page_url . "&time_start=$time_start";
    }
    if ($time_end) {
        $where = $where . " AND add_time < '" . strtotime($time_end) . "'";
        $page_url = $page_url . "&time_end=$time_end";
    }
 
    // 格式化
    $where = $_SESSION['where'] = $dou->where($where);
    $page_url = $dou->param($page_url);
    
    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $dou->table('distribution') . $where . " ORDER BY id DESC";
 
    // 分页
    $page = $check->is_number($_REQUEST['page']) ? $_REQUEST['page'] : 1;
    $limit = $dou->pager($sql, 25, $page, $page_url);
    
    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $distribution_list[] = array (
                "id" => $row['id'],
                "user" => $dou->user_basic($row['user_id']),
                "name" => $row['name'],
                "img_list" => $dou->get_file_list('distribution', $row['user_id'], 'gallery', true),
                "remark" => $row['remark'],
                "handle_record" => $row['handle_record'],
                "handle_time" => $row['handle_time'] ? date("Y-m-d H:i", $row['handle_time']) : '-',
                "status" => $dou->data_lang_format('distribution_status_', $row['status']),
                "add_time" => date("Y-m-d", $row['add_time'])
        );
    }
    
    // 赋值给模板
    $smarty->assign('req', $_REQUEST);
    $smarty->assign('distribution_list', $distribution_list);
    $smarty->assign('page', $page);
    $smarty->assign('submenu', 'people');
    
    $smarty->display('distribution.htm');
}

/**
 * +----------------------------------------------------------
 * 分销编辑
 * +----------------------------------------------------------
 */
elseif ($rec == 'view') {
    $smarty->assign('ur_here', $_LANG['distribution_check']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['distribution_apply'],
            'href' => 'distribution.php' 
    ));
    
    // 验证并获取合法的ID
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';
    
    // 格式化服务单信息
    $distribution = $dou->get_row('distribution', '*', "id = '$id'");
    $distribution['is_handle'] = $distribution['status'] ? true : false; // 是否可以操作分销
    $distribution['status'] = $dou->data_lang_format('distribution_status_', $distribution['status']);
    $distribution['add_time'] = date("Y-m-d H:i:s", $distribution['add_time']);
    $distribution['user'] = $dou->get_row('user', 'user_id, user_sn, email', "user_id = '$distribution[user_id]'");
    $distribution['img_list'] = $dou->get_file_list('distribution', $distribution['user_id'], 'gallery', true);
 
    // 强制解锁
    $unlock = $check->is_letter($_REQUEST['unlock']) ? $_REQUEST['unlock'] : '';
    
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
    
    // 赋值给模板
    $smarty->assign('distribution', $distribution);
    $smarty->assign('unlock', $unlock);
    $smarty->assign('user_level_option', $dou_user->level_option());
    $smarty->assign('submenu', 'people');
    
    $smarty->display('distribution.htm');
}

/**
 * +----------------------------------------------------------
 * 奖励记录
 * +----------------------------------------------------------
 */
elseif ($rec == 'reward') {
    $smarty->assign('ur_here', $_LANG['distribution_reward']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['distribution_apply'],
            'href' => 'distribution.php' 
    ));
    
    // 初始化
    $page_url = 'distribution.php?rec=reward';
    $where = " WHERE (action = 'direct_reward' OR action = 'indirect_reward')";
 
    // 用户名
    $username = $check->is_username($_REQUEST['username']) ? $_REQUEST['username'] : '';
    if ($username) {
        $user_id = $dou->search_user_id($username);
        $where = $where . " AND user_id = '$user_id'";
        $page_url = $page_url . "&username=$username";
    }

    // 来源用户名
    $from_username = $check->is_username($_REQUEST['from_username']) ? $_REQUEST['from_username'] : '';
    if ($username) {
        $user_id = $dou->search_user_id($from_username);
        $where = $where . " AND user_id = '$user_id'";
        $page_url = $page_url . "&from_username=$from_username";
    }

    // 筛选.时间
    $time_end = isset($_REQUEST['time_end']) ? trim($_REQUEST['time_end']) : '';
    $time_start = isset($_REQUEST['time_start']) ? trim($_REQUEST['time_start']) : '';
    if ($time_start) {
        $where = $where . " AND add_time > '" . strtotime($time_start) . "'";
        $page_url = $page_url . "&time_start=$time_start";
    }
    if ($time_end) {
        $where = $where . " AND add_time < '" . strtotime($time_end) . "'";
        $page_url = $page_url . "&time_end=$time_end";
    }
 
    // 格式化
    $page_url = $dou->param($page_url);
 
    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $dou->table('money') . $where . " ORDER BY id DESC";
    
    // 分页
    $page = $check->is_number($_REQUEST['page']) ? $_REQUEST['page'] : 1;
    $limit = $dou->pager($sql, 15, $page, $page_url);
    
    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $money_list[] = array (
                "id" => $row['id'],
                "user" => $dou->user_basic($row['user_id']),
                "action" => $dou_money->action_format($row['action']),
                "from" => $row['from'],
                "from_user_id" => $row['from_user_id'],
                "from_username" => $dou_distribution->username($row['from_user_id']),
                "money" => $row['money'],
                "total" => $row['total'],
                "create_time" => date("Y-m-d H:i", $row['create_time'])
        );
    }
    
    // 赋值给模板
    $smarty->assign('req', $_REQUEST);
    $smarty->assign('money_list', $money_list);
    $smarty->assign('action_list', $dou_money->action_list($action));
    $smarty->assign('submenu', 'reward');
    
    $smarty->display('distribution.htm');
} 

/**
 * +----------------------------------------------------------
 * 分销处理
 * +----------------------------------------------------------
 */
elseif ($rec == 'handle') {
    // 验证并获取合法的ID
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';
    $unlock = $check->is_letter($_REQUEST['unlock']) ? $_REQUEST['unlock'] : '';
 
    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
 
    // 分销信息
    $distribution = $dou->get_row('distribution', '*', "id = '$id'");
    if ($distribution['status'] == 1 && !$unlock) // 强制解锁状态可以重复修改分销信息
        $dou->dou_msg('不能操作该分销申请');
    
    // 格式化数据
    $handle_time = time();
 
    // 变更分销状态
    $dou->query("UPDATE " . $dou->table('distribution') . " SET level_name = '$_POST[level_name]', handle_record = '$_POST[handle_record]', handle_time = '$handle_time', `status` = '1' WHERE id = '$id'");
 
    // 变更会员等级
    $level_id = $dou->get_value('user_level', 'level_id', "name = '$_POST[level_name]'");
    $dou->query("UPDATE " . $dou->table('user') . " SET level_id = '$level_id' WHERE user_id = '$distribution[user_id]'");
    
    $dou->dou_header('distribution.php?rec=view&id=' . $id);
}

?>