<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

$sub = 'user|apply|apply_post';
$subbox = array(
        "module" => 'distribution',
        "sub" => $sub
);

if (!defined('REWRITE')) {
    $_CUR = 'distribution';
    require (dirname(__FILE__) . '/include/init.php');
}
$smarty->assign('cur', $_CUR);
$smarty->assign('url', $_URL = $dou->dou_sub_url($subbox));

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'user';

// 需要登录且没有登录的情况
if (!is_array($_GLOBAL_USER))
    $dou->dou_header($_URL['login']);

// 当前会员ID
$user_id = $_GLOBAL_USER['user_id'];

// 赋值给模板-meta和title信息
$smarty->assign('keywords', $_CFG['site_keywords']);
$smarty->assign('description', $_CFG['site_description']);

// 赋值给模板-导航栏
$smarty->assign('nav_top_list', $dou->get_nav('top'));
$smarty->assign('nav_middle_list', $dou->get_nav('middle', 0, 'user', 0));
$smarty->assign('nav_bottom_list', $dou->get_nav('bottom'));

// 赋值给模板-数据
$smarty->assign('rec', $rec);
$smarty->assign('link_user_center', $dou_user->link_user_center($_CUR));
$smarty->assign('if_connect_plugin', $dou->value_exist('plugin', 'plugin_group', 'connect'));


/**
 * +----------------------------------------------------------
 * 分销.会员中心
 * +----------------------------------------------------------
 */
if ($rec == 'user') {
    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $dou->table('user_distribution') . " WHERE user_id = '$user_id' ORDER BY id DESC";
    
    // 分页
    $page = $check->is_number($_REQUEST['page']) ? $_REQUEST['page'] : 1;
    $limit = $dou->pager($sql, 15, $page, $_URL['sub']['user']);
    
    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $distribution_list[] = array (
                "id" => $row['id'],
                "user" => $dou->user_basic($row['user_id']),
                "distribution_sn" => $row['distribution_sn'],
                "money" => $row['money'],
                "card_number" => $row['card_number'],
                "card_bank" => $row['card_bank'],
                "card_name" => $row['card_name'],
                "handle_record" => $row['handle_record'],
                "handle_time" => $row['handle_time'] ? date("Y-m-d H:i", $row['handle_time']) : '',
                "status" => $dou->data_lang_format('distribution_status_', $row['status']),
                "add_time" => date("Y-m-d", $row['add_time'])
        );
    }
    
    // 赋值给模板
    $smarty->assign('page_title', $dou->page_title('user', 'distribution_list'));
    $smarty->assign('ur_here', $dou->ur_here('user', 'distribution_list'));
    $smarty->assign('head', $_LANG['distribution_list']);
    $smarty->assign('distribution_list', $distribution_list);
    $smarty->assign('money_total', $dou_user->money($user_id));
    $smarty->assign('back_url', $_URL['sub']['user']);

    $smarty->display('distribution.dwt');
}

/**
 * +----------------------------------------------------------
 * 分销.申请
 * +----------------------------------------------------------
 */
elseif ($rec == 'apply') {
    // 验证是否重复申请
    $old_distribution = $dou->get_one("SELECT COUNT(*) FROM " . $dou->table('user_distribution') . " WHERE user_id = '$user_id' AND status = 0");
    if ($old_distribution)
        $dou->dou_msg($_LANG['distribution_apply_exist'], $_URL['list']);
    
    // 获取最近一次的收款账号信息
    $distribution = $dou->get_row('user_distribution', '*', "user_id = '$user_id' ORDER BY id DESC"); // 获取最近一条分销记录
    
    // CSRF防御令牌生成
    $smarty->assign('token', $firewall->set_token('distribution_apply'));

    // 赋值给模板
    $smarty->assign('page_title', $dou->page_title('distribution', 'distribution_apply'));
    $smarty->assign('ur_here', $dou->ur_here('distribution', 'distribution_apply'));
    $smarty->assign('head', $_LANG['distribution_apply']);
    $smarty->assign('distribution', $distribution);
    $smarty->assign('money_total', $dou_user->money($user_id));

    $smarty->display('distribution.dwt');
}

/**
 * +----------------------------------------------------------
 * 分销.提交
 * +----------------------------------------------------------
 */
elseif ($rec == 'apply_post') {
   $distribution = $dou->get_row('user_distribution', '*', "user_id = '$user_id' ORDER BY id DESC"); // 获取最近一条分销记录
   $money = $dou_user->money($user_id); // 获取当前账号余额
   
   // 判断是否为空
    $wrong = $check->fn_empty('distribution', 'money');
    if ($distribution['card_status'] != 1) {
        $wrong = $check->fn_empty('distribution', 'card_number, card_bank, card_name');
        $wrong = $check->fn_illegal_char('distribution', 'card_number, card_bank, card_name');
    }
 
    // 验证分销金额
    if (!$check->is_price($_POST['money']) && $_POST['money'] > 0)
        $wrong['money'] = $_LANG['distribution_money_cue'];

    // 验证最大可分销金额
    if ($_POST['money'] > $money)
        $wrong['money'] = $_LANG['distribution_money_out'];

    // AJAX验证表单
    if ($_REQUEST['do'] == 'callback') {
        if ($wrong) {
            foreach ($_POST as $key => $value) {
                $wrong_json[$key] = $wrong[$key];
            }
            echo json_encode($wrong_json);
        } else {
            echo json_encode('');
        }
        exit;
    }

    if ($wrong) {
        foreach ($wrong as $key => $value) {
            $wrong_format[$key] = '<p class="cue">' . $value . '</p>';
        }
        $dou->dou_msg($wrong_format, $_URL['edit']);
    }
 
    // 验证是否重复申请
    $old_distribution = $dou->get_one("SELECT COUNT(*) FROM " . $dou->table('user_distribution') . " WHERE user_id = '$user_id' AND status = 0");
    if ($old_distribution)
        $dou->dou_msg($_LANG['distribution_apply_exist'], $_URL['list']);
    
    // CSRF防御令牌验证
    $firewall->check_token($_POST['token'], 'distribution_apply');

    // 获取和格式化数据
    $distribution_sn = create_distribution_sn();
    $card_number = $distribution['card_number'] ? $distribution['card_number'] : $_POST['card_number'];
    $card_bank = $distribution['card_bank'] ? $distribution['card_bank'] : $_POST['card_bank'];
    $card_name = $distribution['card_name'] ? $distribution['card_name'] : $_POST['card_name'];
    $add_time = time();

    // 安全处理用户输入信息
    $_POST = $firewall->dou_foreground($_POST);

    // 分销信息插入
    $sql = "INSERT INTO " . $dou->table('user_distribution') . " (id, distribution_sn, user_id, money, card_number, card_bank, card_name, card_status, add_time)" . " VALUES (NULL, '$distribution_sn', '$user_id', '$_POST[money]', '$card_number', '$card_bank', '$card_name', '1', '$add_time')";
    if ($dou->query($sql))
        $dou_user->create_money($user_id, 'distribution', $_POST['money']*(-1), $distribution_sn); // 写入财务记录
 
    $dou->dou_msg($_LANG['distribution_apply_success'], $_URL['sub']['user'], 3);
}

/**
 * +----------------------------------------------------------
 * 生成唯一的退换货编号
 * +----------------------------------------------------------
 */
function create_distribution_sn() {
    // 随机生成订单号
    $distribution_sn = str_pad(mt_rand(1, 99999), 6, '0', STR_PAD_LEFT);

    if ($GLOBALS['dou']->value_exist('user_distribution', 'distribution_sn', $distribution_sn)) {
        create_distribution_sn();
    }

    return $distribution_sn;
}

?>