// pages/distribution/apply.js
// 获取全局的应用实例
const app = getApp();

// 引入utils全局函数
var dou = require('../../utils/util.js');

Page({
  data: {
  },
 
  onShow: function () {
    var that = this;
    
    // 判断是否登录
    dou.checkLoginState()
  },
 
  onLoad: function(options) {
    var that = this
    
    that.setData({
      title: app.title.distribution_apply
    })
    
    // 显示转发按钮
    dou.showShareMenu()
   
    wx.request({
      url: app.mp_url + 'databox.php?rec=common',
      success: function(res) {
        that.setData({
          lang: res.data.lang,
          site: res.data.site
        })
      },
    })
    
    wx.request({
      url: app.mp_url + 'distribution.php?rec=apply',
      data: {
        user_id: wx.getStorageSync('user_id'),
        shell: wx.getStorageSync('shell')
      },
      header: {
        'Connect-Key' : wx.getStorageSync('connect_key')
      },
      success: function(res) {
        if (res.data.wrong) {
          dou.douMsg(res.data.wrong, '/pages/distribution/user')
        }
        
        that.setData({
          distribution: res.data.distribution,
          img_list: res.data.img_list,
          item_id: res.data.item_id
        })
      },
    })
  },
 
  distributionApply: function (e) {
    var that = this
    
    // 未登录时重新载入当前页面
    dou.checkLoginState('action', '/pages/user/user')
   
    wx.request({
    url: app.mp_url + 'distribution.php?rec=apply_post',
    data: {
      user_id: wx.getStorageSync('user_id'),
      shell: wx.getStorageSync('shell'),
      name: e.detail.value.name,
      remark: e.detail.value.remark
    },
    method:'POST',
    header: {
      'Connect-Key' : wx.getStorageSync('connect_key'),
      'Content-Type': 'application/x-www-form-urlencoded'
    },
    success: function (res) {
      if (res.data.wrong) {
        if (res.data.wrong.toast) {
          dou.douMsg(res.data.wrong.toast)
        } else {
          that.setData({
            wrong: data.wrong
          })
        }
      } else {
        wx.redirectTo({
          url: '/pages/distribution/apply'
        })
      }
    }
   })
  },
 
  // 文件上传
  filebox: function(e) {
    var dataset = e.currentTarget.dataset;
    dou.filebox(
      {dataset}, (img_list) => {
        this.setData({img_list: img_list});
      }
    );
  },
 
  // 文件删除
  fileDel: function (e) {
    var dataset = e.currentTarget.dataset;
    dou.fileDel(
      {dataset}, (img_list) => {
        this.setData({img_list: img_list});
      }
    );
  },
 
  // 非tabBar的页面，可以带参数
  douNavigateTo: function(e) {
    var url = e.currentTarget.dataset.url;
    wx.navigateTo({
      url: url
    })
  }

})