<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

$sub = 'user|apply|people';
$subbox = array(
        "module" => 'distribution',
        "sub" => $sub
);

$_CUR = 'distribution';
require (dirname(__FILE__) . '/include/init.php');

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'user';

// 引入和实例化分销功能
include_once (ROOT_PATH . 'include/distribution.class.php');
$dou_distribution = new Distribution();

// 引入和实例化订单功能
include_once (ROOT_PATH . 'include/money.class.php');
$dou_money = new Money();

// 图片上传
include_once (ROOT_PATH . 'include/file.class.php');
$file = new File('images/distribution/' . date('Ymd') . '/'); // 实例化类文件(文件上传路径，结尾加斜杠)

// 权限验证
$callback = $dou_user->check_login_state(); // 登录验证
if ($callback['msg'] == 'ok') {
    $user_id = $callback['user_id'];
    $distribution = $dou_user->distribution($user_id);
    if ($distribution) {
        $distribution['status'] = $dou->data_lang_format('distribution_status_', $distribution['status']);
    }
} else {
    $data['wrong'] = $_LANG['login_timeout'];
    die(json_encode($data));
}

// 错误提示初始
$data['wrong'] = '';

/**
 * +----------------------------------------------------------
 * 分销.会员中心
 * +----------------------------------------------------------
 */
if ($rec == 'user') {
    if (!$distribution) {
        // 错误提示
        $data['wrong'] = 'need_apply';
        die(json_encode($data));
    }
    
    $user_sn = $check->is_number($_REQUEST['user_sn']) ? $_REQUEST['user_sn'] : '';
    if ($user_sn) {
        $from_user_id = $dou->get_value('user', 'user_id', "user_sn = '$user_sn'");
        $and = " AND from_user_id = '$from_user_id'";
    }
    
    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $dou->table('money') . " WHERE user_id = '$user_id' AND (action = 'direct_reward' OR action = 'indirect_reward')" . $and . " ORDER BY id DESC";
    
    // 获取分页信息
    $page = $check->is_number($_REQUEST['page']) ? trim($_REQUEST['page']) : 1;
    $limit = $dou->pager($sql, 10, $page);
    
    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $money_list[] = array (
                "id" => $row['id'],
                "action" => $dou_money->action_format($row['action']),
                "from" => $row['from'],
                "from_username" => $dou_distribution->username($row['from_user_id']),
                "money" => $dou->price_format($row['money']),
                "total" => $dou->price_format($row['total']),
                "create_time" => date("Y-m-d H:i", $row['create_time'])
        );
    }
 
    // 验证是否重复申请
    $old_distribution = $dou->get_one("SELECT COUNT(*) FROM " . $dou->table('user_distribution') . " WHERE user_id = '$user_id' AND status = 0");
    
    if ($old_distribution) {
        $data['apply_exist'] = true;
    }
 
    // 数据封装
    $data['title'] = $_LANG['distribution_user'];
    $data['money_list'] = $money_list;
}

/**
 * +----------------------------------------------------------
 * 分销.推荐记录
 * +----------------------------------------------------------
 */
elseif ($rec == 'people') {
    if (!$distribution) {
        // 错误提示
        $data['wrong'] = 'need_apply';
        die(json_encode($data));
    }
    
    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $dou->table('user') . " WHERE direct_user_id = '$user_id' ORDER BY user_id DESC";
    
    // 分页
    $page = $check->is_number($_REQUEST['page']) ? $_REQUEST['page'] : 1;
    $limit = $dou->pager($sql, 20, $page, $_URL['sub']['people']);
    
    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        // 判断是否有间接推荐人
        $indirect_user_id = $dou->get_value('user', 'user_id', "direct_user_id = '$row[user_id]'");
        $indirect_user = $dou->get_row('user', '*', "user_id = '$indirect_user_id'");
        if ($indirect_user) {
            $indirect = array (
                    "username" => $dou_distribution->username($indirect_user['user_id']),
                    "level_name" => $dou_user->level_name($indirect_user['level_id']),
                    "reward" => $dou_distribution->reward_from_user('indirect', $user_id, $indirect_user['user_id']),
                    "type" => $_LANG['distribution_people_indirect'],
                    "url" => $page_url = $dou->param($_URL['sub']['user'] . '&user_sn=' . $indirect_user['user_sn']),
                    "add_time" => date("Y-m-d H:i", $indirect_user['add_time'])
            );
        }
        
        $people_list[] = array (
                "username" => $dou_distribution->username($row['user_id']),
                "level_name" => $dou_user->level_name($row['level_id']),
                "reward" => $dou_distribution->reward_from_user('direct', $user_id, $row['user_id']),
                "type" => $_LANG['distribution_people_direct'],
                "url" => $page_url = $dou->param($_URL['sub']['user'] . '&user_sn=' . $row['user_sn']),
                "add_time" => date("Y-m-d H:i", $row['add_time']),
                "indirect" => $indirect
        );
    }
 
    // 数据封装
    $data['title'] = $_LANG['distribution_people'];
    $data['people_list'] = $people_list;

}

/**
 * +----------------------------------------------------------
 * 分销.申请
 * +----------------------------------------------------------
 */
elseif ($rec == 'apply') {
    // 使用user_id作为文件系统的item_id
    $item_id = $user_id;
 
    // 数据封装
    $data['title'] = $_LANG['distribution_apply'];
    $data['distribution'] = $distribution;
    $data['item_id'] = $item_id;
    $data['img_list'] = $dou->get_file_list('distribution', $item_id, 'gallery', true);
}

/**
 * +----------------------------------------------------------
 * 分销.提交
 * +----------------------------------------------------------
 */
elseif ($rec == 'apply_post') {
    // 判断是否为空
    $wrong = $check->fn_empty('distribution', 'name');
    $wrong = $check->fn_illegal_char('distribution', 'name, remark');
 
    // 验证是否重复申请
    if ($dou->value_exist('distribution', 'user_id', $user_id))
        $wrong['toast'] = $_LANG['distribution_apply_exist'];

    // 错误提示
    $data['wrong'] = $wrong;
    if ($data['wrong']) {
        die(json_encode($data));
    }
 
    // 获取和格式化数据
    $add_time = time();

    // 安全处理用户输入信息
    $_REQUEST = $firewall->dou_foreground($_REQUEST);

    // 分销信息插入
    $sql = "INSERT INTO " . $dou->table('distribution') . " (id, user_id, name, remark, add_time)" . " VALUES (NULL, '$user_id', '$_REQUEST[name]', '$_REQUEST[remark]', '$add_time')";
    $dou->query($sql);
 
    $data['sql'] = $sql;
}

echo json_encode($data);

/**
 * +----------------------------------------------------------
 * 生成唯一的退换货编号
 * +----------------------------------------------------------
 */
function create_distribution_sn() {
    // 随机生成订单号
    $distribution_sn = str_pad(mt_rand(1, 99999), 6, '0', STR_PAD_LEFT);

    if ($GLOBALS['dou']->value_exist('user_distribution', 'distribution_sn', $distribution_sn)) {
        create_distribution_sn();
    }

    return $distribution_sn;
}

?>